var CODE_NO_NETWORK = 0;//没有网络连接
var CODE_INIT_SUCCESS = 1;//初始化成功
var CODE_INIT_FAIL = 2;//初始化失败
var CODE_LOGIN_SUCCESS = 3;//登录成功
var CODE_LOGIN_FAIL = 4;//登录失败
var CODE_LOGIN_CANCEL = 5;//登录取消
var CODE_AUTH_TOKEN_SUCCESS = 6;//验证token成功
var CODE_AUTH_TOKEN_FAIL = 7;//验证token失败
var CODE_SW_LOGIN_SUCCESS = 8;//切换账号登录成功
var CODE_SW_LOGIN_FAIL = 9;//切换账号登录失败
var CODE_LOGOUT_SUCCESS = 10;//登出成功
var CODE_LOGOUT_FAIL = 11;//登出失败
var CODE_PAY_SUCCESS = 12;//支付成功
var CODE_PAY_FAIL = 13;//支付失败
var CODE_PAY_CANCEL = 14;//支付取消
var CODE_PAY_UNKNOWN = 15;//支付未知
var CODE_PAYING = 16;//支付中
var CODE_REAL_NAME_REG_SUC = 17;//实名注册成功

if(window['plus']){
    initSJSDK5Plus();
}else{
    document.addEventListener("plusready",  initSJSDK5Plus, true );
}
    

function initSJSDK5Plus(){
    var _BARCODE = 'sjsdkh5bridge',
	plusBridge = window.plus.bridge;
    var sjSdkH5Bridge =
    {
        init : function (appId, appKey, privateKey, successCallback, errorCallback)
        {
            console.log("调用sujieinit这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);

            return plusBridge.exec(_BARCODE, "init", [callbackID, appId, appKey, privateKey]);
        },
        login : function (successCallback, errorCallback)
        {
            console.log("调用login这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);

            return plusBridge.exec(_BARCODE, "login", [callbackID]);
        },
        logout : function (successCallback, errorCallback)
        {
            console.log("调用logout这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);

            return plusBridge.exec(_BARCODE, "logout", [callbackID]);
        },
        pay : function (payParams, successCallback, errorCallback)
        {
            console.log("调用pay这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);

            return plusBridge.exec(_BARCODE, "pay", [callbackID, payParams]);
        },
        submitExtraData : function (roleData, successCallback, errorCallback)
        {
            console.log("调用submitExtraData这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);

            return plusBridge.exec(_BARCODE, "submitExtraData", [callbackID, roleData]);
        },
        getDeviceInfo : function (successCallback, errorCallback)
        {
            console.log("调用getDeviceInfo这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);

            return plusBridge.exec(_BARCODE, "deviceInfo2JS", [callbackID]);
        },

        addLocalNotification : function (notificationInfo, successCallback, errorCallback)
        {
            console.log("调用addLocalNotification这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                 errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);
            return plusBridge.exec(_BARCODE, "addLocalNotification", [callbackID, notificationInfo]);
        },

        cancelAllLocalNotification : function (successCallback, errorCallback)
        {
            console.log("调用cancelAllLocalNotification这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);
            return plusBridge.exec(_BARCODE, "cancelAllLocalNotification", [callbackID]);
        },

        cancelNotificationById : function (notificationId, successCallback, errorCallback)
        {
            console.log("调用getDeviceInfo这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);
            return plusBridge.exec(_BARCODE, "cancelNotificationById", [callbackID, notificationId]);
        }
    };

    var webview = plus.webview.currentWebview();
    plus.key.addEventListener('backbutton', function() {
        webview.canBack(function(e) {
            console.log("调用backbutton这个方法成功");
            var success = typeof successCallback !== 'function' ? null : function(args)
            {
                successCallback(args);
            },
            fail = typeof errorCallback !== 'function' ? null : function(code)
            {
                errorCallback(code);
            };
            callbackID = plusBridge.callbackId(success, fail);
            return plusBridge.exec(_BARCODE, "exit", [callbackID]);
        })
    });

    window.plus.sjSdkH5Bridge = sjSdkH5Bridge;
    if (window.sjInitInfo) {
        var appId = window.sjInitInfo.appId;
        var appKey = window.sjInitInfo.appKey;
        var privateKey = window.sjInitInfo.privateKey;
        var successCallback = window.sjInitInfo.successCallback;
        var errorCallback = window.sjInitInfo.errorCallback;
        plus.sjSdkH5Bridge.init(appId, appKey, privateKey, successCallback, errorCallback);
        window.sjInitInfo = null;
    };
}

/**
 * 速接初始化方法
 * @param appId 速接分配的appid
 * @param appKey 速接分配的appkey
 * @param privateKey 速接分配的privatekey
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkInit(appId, appKey, privateKey, successCallback, errorCallback){
    try{
        plus.sjSdkH5Bridge.init(appId, appKey, privateKey, successCallback, errorCallback);
    }catch(err){
        window.sjInitInfo.appId = appId;
        window.sjInitInfo.appKey = appKey;
        window.sjInitInfo.privateKey = privateKey;
        window.sjInitInfo.successCallback = successCallback;
        window.sjInitInfo.errorCallback = errorCallback;
    }
    
}

/**
 * 速接登录方法
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkLogin(successCallback, errorCallback){
    plus.sjSdkH5Bridge.login(successCallback, errorCallback);
}

/**
 * 速接注销方法
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkLogout(successCallback, errorCallback){
    plus.sjSdkH5Bridge.logout(successCallback, errorCallback);
}

/**
 * 速接支付方法
 * @param payParams 支付参数，需要为json字符串
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkPay(payParams, successCallback, errorCallback){
    plus.sjSdkH5Bridge.pay(payParams, successCallback, errorCallback);
}

/**
 * 速接初始化方法
 * @param roleData 用户信息，需要时json字符串
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkSubmitExtraData(roleData, successCallback, errorCallback){
    plus.sjSdkH5Bridge.submitExtraData(roleData, successCallback, errorCallback);
}

/**
 * 获取手机信息
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkGetDeviceInfo(successCallback, errorCallback){
    plus.sjSdkH5Bridge.getDeviceInfo(successCallback, errorCallback);
}

/**
 * 设置本地推送
 * @param notificationInfo 推送信息，json格式
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkAddLocalNotification(notificationInfo, successCallback, errorCallback){
    plus.sjSdkH5Bridge.addLocalNotification(notificationInfo, successCallback, errorCallback);
}

/**
 * 根据ID取消计划推送
 * @param notificationId 推送ID，请保持唯一
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkCancelNotificationById(notificationId, successCallback, errorCallback){
    plus.sjSdkH5Bridge.cancelNotificationById(notificationId, successCallback, errorCallback);
}

/**
 * 取消所有计划推送
 * @param successCallback 成功回调
 * @param errorCallback 失败回调
 */
function sjSdkCancelAllNotification(successCallback, errorCallback){
    plus.sjSdkH5Bridge.cancelAllLocalNotification(successCallback, errorCallback);
}

